;; nanoGUI/theme.jl

;; Copyright (C) 1999 Mike Rosellini <mike@unlikely.org>

;; This theme was based on the microGUI by Ryan Lovett
;; <ryan@ocf.berkeley.edu>.  Both the Lisp and the border images
;; were simplified to my tastes from Ryan's theme.  Thanks to John
;; Harper <john@dcs.warwick.ac.uk> for making the modifications for
;; lexical scope to microGUI so that I might duplicate them here
;; and, of course, for writing Sawmill.

(let*
    (
     ;; 14x5
     (bottom-image (make-image "b.xpm"))

     ;; 5x5
     (top-left-image (make-image "tl.xpm"))

     ;; 14x5
     (top-image (make-image "t.xpm"))

     ;; 5x5
     (top-right-image (make-image "tr.xpm"))

     ;; 5x5
     (bottom-left-image (make-image "bl.xpm"))

     ;; 5x5
     (bottom-right-image (make-image "br.xpm"))

     ;; 5x14
     (left-image (make-image "l.xpm"))

     ;; 5x14
     (right-image (make-image "r.xpm"))


     (frame `(
          ;; top-left corner
          ((background . ,top-left-image)
	       (left-edge . -5)
	       (top-edge . -5)
	       (class . top-left-corner))

	      ;; left border
	      ((background . ,left-image)
	       (left-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; top-right corner
	      ((background . ,top-right-image)
	       (right-edge . -5)
	       (top-edge . -5)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,right-image)
	       (right-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom border
	      ((background . ,bottom-image)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -5)
	       (class . bottom-border))

	      ;; top border
	      ((background . ,top-image)
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . -5)
	       (class . top-border))

	      ;; bottom-left corner
	      ((background . ,bottom-left-image)
	       (left-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,bottom-right-image)
	       (right-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-right-corner)))))

  (add-frame-style 'nanoGUI
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    nil-frame)
			   ((eq type 'transient)
			    frame)
			   ((eq type 'shaped-transient)
			    nil-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
	      (rebuild-frames-with-style 'nanoGUI))))
